import {MastodonHandler} from "./mastodonHandler.js";
import {MastodonTokenHandler} from "./mastodonTokenHandler.js";
import {MemeHandler} from "./memeHandler.js";

const baseUrl = "https://social.cybre.town";
const memeAPI = "http://redditapi.adb.sh/api/v1/";
const subreddits = ["r/programmerhumor/random"];
const allowedMedia = ["jpg", "jpeg", "gif", "png"];
const interval = 1000*60*60;

let tokenHandler = new MastodonTokenHandler(baseUrl);
tokenHandler.getAccessToken((accessToken) => {
    let client = new MastodonHandler(baseUrl, accessToken);
    let memeHandler = new MemeHandler(memeAPI, subreddits, allowedMedia);
    setInterval(() => {
        memeHandler.getRandomMeme(sub => {
            let status = `"${sub.title}"\n${sub.text}\nby ${sub.author}`;
            if (allowedMedia.find(type => type === sub.url.split(/[.]+/).pop())){
                let filepath = `./media/${sub.url.split(/[/]+/).pop()}`;
                memeHandler.downloadMedia(sub.url, filepath, () => {
                    client.postMedia(status, filepath);
                })
            }else{
                client.postStatus(status);
            }
        })
    }, interval);
});
