import Mastodon from "mastodon-api";
import fs from "fs";

export class MastodonHandler{
    constructor(baseUrl, token) {
        this.client = new Mastodon({
            api_url: `${baseUrl}/api/v1/`,
            access_token: token,
        })
    }
    postStatus(status){
        this.client.post('statuses', {status: status}).then((resp) => console.log(resp.data))
    }
    postMedia(status, mediaPath){
        this.client.post('media', { file: fs.createReadStream(mediaPath) }).then(resp => {
            let id = resp.data.id;
            this.client.post('statuses', { status: status, media_ids: [id] }).then((resp) => console.log(resp.data))
        });
    }
}